import configparser

from etcd_wrapper import EtcdWrapper

config = configparser.ConfigParser(allow_no_value=True)
config.read('config-and-secrets.conf')

etcd_client = EtcdWrapper(
    host=config['etcd']['url'], port=config['etcd']['port'],
    ca_cert=config['etcd']['ca_cert'], cert_key=config['etcd']['cert_key'],
    cert_cert=config['etcd']['cert_cert']
)
